﻿Imports YiaoWang.DataBase
Imports YiaoWang.Windows.Forms
Imports YiaoWang.Vender.Office
Imports YiaoWang.Utility
Imports System.Globalization
Imports System.Reflection
Imports System.Windows.Forms

''' <summary>
''' スタートアップ オブジェクトを示します。
''' </summary>
''' <remarks></remarks>
Module Program

#Region " メイン処理 "

    ''' <summary>
    ''' プログラムを開始します。
    ''' </summary>
    ''' <remarks></remarks>
    <STAThread()> _
    Public Sub Main(ByVal args As String())

        Try
            ' ThreadException / UnhandledException イベント・ハンドラの登録
            AddHandler Application.ThreadException, AddressOf Application_ThreadException
            AddHandler Threading.Thread.GetDomain().UnhandledException, AddressOf Application_UnhandledException

            ' WindowsアプリケーションをWindows XPスタイルの外観にする
            Application.EnableVisualStyles()
            Application.DoEvents()

            YWSplashManager.ShowSplashForm()

            ' INIの初期化
            C.CINI.Initialize()

            ' DBインスタンス作成
            M.MDB.Initialize()

            ' 初期DBアクセス時の画面名を設定
            M.MDB.CRUDFormName = "Program"

            If args.Length < 2 Then ReDim args(2)
            Dim ユーザーCD As String = args(0)
            Dim パスワード As String = args(1)

            YWSplashManager.HideSplashForm()
            Application.Run(New V.FM_ログイン(ユーザーCD, パスワード))

            Environment.Exit(0)
        Catch ex As Exception
            ShowErrorMessage(ex)
        Finally
            M.MDB.Quit()
            End
        End Try
    End Sub

#End Region

#Region " 例外処理 "

    Private Sub Application_ThreadException(ByVal sender As Object, ByVal e As Threading.ThreadExceptionEventArgs)
        '未処理例外をキャッチするイベント・ハンドラ
        '（Windowsアプリケーション用）
        ShowErrorMessage(e.Exception)
    End Sub

    Private Sub Application_UnhandledException(ByVal sender As Object, ByVal e As UnhandledExceptionEventArgs)
        '未処理例外をキャッチするイベント・ハンドラ 
        '（主にコンソール・アプリケーション用） 
        Dim ex As Exception = CType(e.ExceptionObject, Exception)
        If Not ex Is Nothing Then
            ShowErrorMessage(ex)
        End If
    End Sub

    Private Sub ShowErrorMessage(ByVal ex As Exception)
        '例外メッセージ
        Dim invokeAttr As BindingFlags = BindingFlags.NonPublic Or BindingFlags.Instance Or BindingFlags.Public Or BindingFlags.GetProperty
        Dim hResult As Integer = Convert.ToInt32(GetType(Exception).InvokeMember("HResult", invokeAttr, Nothing, ex, Nothing, CultureInfo.InvariantCulture))
        Dim msg As New YWMsg()
        msg.AddLN(CMsg.EAC01)
        msg.AddLN("メッセージのハードコピーを撮り、開発元にお問い合わせください。")
        msg.AddLN("")
        msg.AddLN(SFormat("{0}({1})", ex.GetType.ToString, hResult))
        msg.AddLN(ex.Message)
        msg.AddLN("")
        msg.AddLN(ex.StackTrace)
        msg.ShowE()
        Environment.Exit(hResult)
    End Sub

#End Region

End Module
