﻿Imports System.Windows.Forms
Imports YiaoWang.DataBase
Imports YiaoWang.Network
Imports YiaoWang.Utility
Imports YiaoWang.Vender.Office
Imports YiaoWang.Windows.Forms

Public Class YWFormsSample

#Region " New "

    Public Sub New()
        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
    End Sub

#End Region

#Region " Control(1) "

#Region " YWBtton "

    Private Sub btnYwButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYWButton.Click
        ' クリックイベント中は、自動でマウスカーソルが砂時計になります。
        System.Threading.Thread.Sleep(1000)

        Dim msg As New YWMsg()
        msg.AddLN("YwBtton Click")
        msg.ShowI(Me)
    End Sub

#End Region

#Region " YWLinkLabel "

    Private Sub lnkLinkLabel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkYWLinkLabel.Click
        ' クリックイベント中は、自動でマウスカーソルが砂時計になります。
        System.Threading.Thread.Sleep(1000)

        Dim msg As New YWMsg()
        msg.AddLN("YWLinkLabel Click")
        msg.ShowI(Me)
    End Sub

#End Region

#Region " YWLabelButton "

    ''' <summary>
    ''' YwLabelButtonのクリックイベントを取得します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub lbnLabelButton_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkYWLinkLabel.LinkClicked
        ' ボタンクリックイベント中は、自動でマウスカーソルが砂時計になります。
        System.Threading.Thread.Sleep(3000)

        Dim msg As New YWMsg()
        msg.AddLN("YwLabelButton Click")
        msg.ShowI(Me)
    End Sub

#End Region

#Region " YWCmboBox "

    ''' <summary>
    ''' データを取得してコンボボックスに設定します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSetYwCmboBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetYwCmboBox.Click
        ' ダミーデータ
        Dim dt As New DataTable
        dt.Columns.Add("KEY")
        dt.Columns.Add("NAME")
        dt.Rows.Add("A", "あ")
        dt.Rows.Add("B", "い")
        dt.Rows.Add("C", "う")

        Me.cboYwComboBox.SetTable(dt, "KEY", "NAME")
    End Sub

    ''' <summary>
    ''' 選択しているコンボボックスの値を取得します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnGetYwCmboBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetYwCmboBox.Click
        Dim s As New System.Text.StringBuilder()
        s.AppendLine(String.Format("Index = {0}", Me.cboYwComboBox.SelectedIndex))
        s.AppendLine(String.Format("Value = {0}", Me.cboYwComboBox.Value))
        s.AppendLine(String.Format("Text = {0}", Me.cboYwComboBox.Text))
        MessageBox.Show(s.ToString())
    End Sub

#End Region

#Region " YWFileDialogButton "

    ''' <summary>
    ''' ファイルを開くダイアログボックスを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub fibOpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fibOpenFile.Click
        Dim msg As New YWMsg()
        msg.AddLN("FileName：{0}", Me.fibOpenFile.FileName)
        msg.ShowI(Me)
    End Sub

    ''' <summary>
    ''' ファイルを保存するダイアログボックスを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub fibSaveFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fibSaveFile.Click
        Dim msg As New YWMsg()
        msg.AddLN("FileName：{0}", Me.fibSaveFile.FileName)
        msg.ShowI(Me)
    End Sub

#End Region

#Region " YWFolderDialogButton "

    ''' <summary>
    ''' フォルダの参照ダイアログボックスを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub fobYwFolderDialogButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fobYwFolderDialogButton.Click
        Dim msg As New YWMsg()
        msg.AddLN("SelectedPath：{0}", Me.fobYwFolderDialogButton.SelectedPath)
        msg.ShowI(Me)
    End Sub

#End Region

#Region " YWStrTxtBox "

    ''' <summary>
    ''' テキスト時に別のコントロールに連動してカナを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>通常は、コンストラクタかフォームロード時に行います。</remarks>
    Private Sub btnBindKanaControl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBindKanaControl.Click
        Me.txtKanaF.BindKanaControl(Me.txtKanaT, ImeMode.Katakana)
    End Sub

#End Region

#Region " YWDateTextBox "

    Private Sub btnYMD_Text_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYMD_Text.Click
        Dim msg As New YWMsg()
        msg.AddLN("Text = ""{0}""", Me.dtpYearMonthDay.Text)
        msg.ShowI(Me)
    End Sub

    Private Sub btnYMD_StrValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYMD_StrValue.Click
        Dim msg As New YWMsg()
        msg.AddLN("StrValue = ""{0}""", Me.dtpYearMonthDay.StrValue)
        msg.ShowI(Me)
    End Sub

    Private Sub btnYMD_DateValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYMD_DateValue.Click
        Dim msg As New YWMsg()
        msg.AddLN("DateValue = {0}", Me.dtpYearMonthDay.DateValue)
        msg.ShowI(Me)
    End Sub

    Private Sub btnYM_Text_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYM_Text.Click
        Dim msg As New YWMsg()
        msg.AddLN("Text = ""{0}""", Me.dtpYearMonth.Text)
        msg.ShowI(Me)
    End Sub

    Private Sub btnYM_StrValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYM_StrValue.Click
        Dim msg As New YWMsg()
        msg.AddLN("StrValue = ""{0}""", Me.dtpYearMonth.StrValue)
        msg.ShowI(Me)
    End Sub

    Private Sub btnYM_DateValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYM_DateValue.Click
        Dim msg As New YWMsg()
        msg.AddLN("DateValue = {0}", Me.dtpYearMonth.DateValue)
        msg.ShowI(Me)
    End Sub

    Private Sub btnY_Text_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnY_Text.Click
        Dim msg As New YWMsg()
        msg.AddLN("Text = ""{0}""", Me.dtpYear.Text)
        msg.ShowI(Me)
    End Sub

    Private Sub btnY_StrValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnY_StrValue.Click
        Dim msg As New YWMsg()
        msg.AddLN("StrValue = ""{0}""", Me.dtpYear.StrValue)
        msg.ShowI(Me)
    End Sub

    Private Sub btnY_DateValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnY_DateValue.Click
        Dim msg As New YWMsg()
        msg.AddLN("DateValue = {0}", Me.dtpYear.DateValue)
        msg.ShowI(Me)
    End Sub

#End Region

#Region " YWNumTxtBox "

    ''' <summary>
    ''' YwCalcForm：簡易電卓ダイアログと連携します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnYwCalcForm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYWCalcForm.Click
        Dim frm As New YiaoWang.Windows.Forms.YWCalculatorForm
        frm.ShowDialog(Me, Me.btnYWCalcForm)
        frm.Dispose()
        If frm.DialogResult <> DialogResult.OK Then Return
        Me.txtNumCurrency.Text = frm.Value.ToString
    End Sub

#End Region

#Region " YWTerop "

    ''' <summary>
    ''' テロップを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnStartDraw_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartDraw.Click
        Dim s As New YWStrBuilder()
        s.AddLN("雨ニモマケズ")
        s.AddLN("風ニモマケズ")
        s.AddLN("雪ニモ夏ノ暑サニモマケヌ")
        s.AddLN("丈夫ナカラダヲモチ")
        s.AddLN("慾ハナク")
        s.AddLN("決シテ瞋ラズ")
        s.AddLN("イツモシヅカニワラッテヰル")
        Me.trpTerop.Text = s.ToString()
        Me.trpTerop.StartDraw()
    End Sub

#End Region

#End Region

#Region " Control(2) "

#Region " YWDataGridView "

    Private Sub btnSetGridData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetGridData.Click
        Dim dgv As YWDataGridView = Me.dgvYWDataGridView
        Dim dtCombo As New DataTable
        dtCombo.Columns.Add("CBO_ID")
        dtCombo.Columns.Add("CBO_NAME")
        dtCombo.Rows.Add("1", "有効")
        dtCombo.Rows.Add("2", "無効")
        dgv.SetComboBoxData("COL_CBO", dtCombo, "CBO_ID", "CBO_NAME")

        Dim dtGrid As New DataTable
        dtGrid.Columns.Add("COL_TXT", GetType(String))
        dtGrid.Columns.Add("COL_CBO", GetType(String))
        dtGrid.Columns.Add("COL_CHK", GetType(Boolean))
        dtGrid.Columns.Add("COL_DEC", GetType(Decimal))
        dtGrid.Columns.Add("COL_BTN", GetType(String))
        dtGrid.Columns.Add("COL_DTP", GetType(String))
        dtGrid.Rows.Add("Ａ", "2", True, 0, "Button1", "")
        dtGrid.Rows.Add("Ｂ", "1", True, 0, "Button2", "2004/12/21")
        dtGrid.Rows.Add("Ｃ", "1", False, 0, "Button3", "2001/03/15")
        dtGrid.Rows.Add("Ｄ", "1", False, 0, "Button4", "")
        dtGrid.Rows.Add("Ｅ", "2", True, 0, "Button5", "2010/02/08")
        dtGrid.Rows.Add("Ｆ", "1", False, 0, "Button6", "2001/01/01")
        Me.dgvYWDataGridView.SetDataTable(dtGrid)
    End Sub

    ''' <summary>
    ''' セルに対するスタイルの設定を記述します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' バインドされたDataGridViewでソートするとセルの色といったセルに対する設定の一部が元に戻ってしまうため
    ''' CellFormatting で設定する必要があります。
    ''' </remarks>
    Private Sub dgvYWDataGridView_CellFormatting(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellFormattingEventArgs) Handles dgvYWDataGridView.CellFormatting
        Dim dgvc As DataGridViewColumn = Me.dgvYWDataGridView.Columns(e.ColumnIndex)
        Select Case dgvc.Name
            Case "COL_CHK"
                ' YWDataGridViewChecBoxCell を無効化
                Dim dgvr As DataGridViewRow = Me.dgvYWDataGridView.Rows(e.RowIndex)
                Dim val As String = dgvr.Cells("COL_CBO").Value.ToString()
                Dim chk As YWDataGridViewCheckBoxCell = DirectCast(dgvr.Cells("COL_CHK"), YWDataGridViewCheckBoxCell)
                chk.Enabled = (val = "1")
            Case "COL_BTN"
                ' YWDataGridViewButtonCell を無効化
                Dim dgvr As DataGridViewRow = Me.dgvYWDataGridView.Rows(e.RowIndex)
                Dim checked As Boolean = CBool(dgvr.Cells("COL_CHK").Value)
                Dim btn As YWDataGridViewButtonCell = DirectCast(dgvr.Cells("COL_BTN"), YWDataGridViewButtonCell)
                btn.Enabled = checked
        End Select
    End Sub

    ''' <summary>
    ''' Cell がクリックされた際の制御を記述します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub dgvYWDataGridView_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvYWDataGridView.CellContentClick
        Dim dgvc As DataGridViewColumn = Me.dgvYWDataGridView.Columns(e.ColumnIndex)
        Select Case dgvc.Name
            Case "COL_CHK"
                ' DataGridViewCheckBoxCell チェック ボックスが値を変更する前に発生するため、
                ' 値を確定させて CellEndEdit イベントで処理をします。
                ' http://msdn.microsoft.com/ja-jp/library/system.windows.forms.datagridview.cellcontentclick.aspx
                Dim dgvr As DataGridViewRow = Me.dgvYWDataGridView.Rows(e.RowIndex)
                Me.dgvYWDataGridView.EndEdit()
            Case "COL_BTN"
                'YWDataGridViewButtonCell.Enabled = False の場合は、イベントが発生しません。
                Me.lstYWDataGridViewValue.InsertFormat(0, "{0}:{1} {2}", e.ColumnIndex, e.RowIndex, "Button_Click")
        End Select
    End Sub

    ''' <summary>
    ''' ヘッダーをもう１段追加します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSetGridHeader_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetGridHeader.Click
        Me.dgvYWDataGridView.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing
        Me.dgvYWDataGridView.ColumnHeadersHeight = 40
        Dim spans() As Integer = {2, 0, 1, 1}
        Dim texts() As String = {"結合", "", "単一", "単一"}
        Me.dgvYWDataGridView.SetSubColumnHeader(spans, texts)
    End Sub

    Private Sub dgvYwDataGridView_CellEndEdit(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvYWDataGridView.CellEndEdit
        ' グリッド内のコンボはドロップダウンリストが閉じられたタイミングでデータが確定します。
        Dim colName As String = Me.dgvYWDataGridView.Columns(e.ColumnIndex).DataPropertyName
        Me.lstYWDataGridViewValue.InsertFormat(0, "{0}:{1} {2}", e.ColumnIndex, e.RowIndex, dgvYWDataGridView.GetCurrentRow().Item(colName))
    End Sub

#End Region

#End Region

#Region " Control(3) "

#Region " YWScheduler "

    ''' <summary>
    ''' スケジューラーのカレンダーを設定します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnDisplaySheduler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisplaySheduler.Click
        If Me.txtShedulerDate.IsNoValue Then
            MessageBox.Show("年月を入力してください。")
            Return
        End If
        Me.scdYwScheduler.SetCalendar(Me.txtShedulerDate.DateValue)
        ' カレンダーの値をクリアした場合はClear()を使用します。（＊日付も消えます。）
    End Sub

#End Region

#Region " YWFolderTreeView "

    ''' <summary>
    ''' YWFolderTreeView を初期化します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnTreeViewInitialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTreeViewInitialize.Click
        Me.ftvYWFolderTreeView.Initialize()
    End Sub

#End Region

#End Region

#Region " Manager "

#Region " SplashManager "

    ''' <summary>
    ''' スプラッシュフォームを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSplashShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSplashShow.Click
        YWSplashManager.ShowSplashForm()
    End Sub

    ''' <summary>
    ''' スプラッシュフォームを消去します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSplashHide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSplashHide.Click
        YWSplashManager.HideSplashForm()
    End Sub

#End Region

#End Region

#Region " Form "

    ''' <summary>
    ''' YwForm：画面のプリントスクリーンの印刷プレビューダイアログを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrintScreenShowDialog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintScreenShowDialog.Click
        Me.ShowScreenShotDialog()
    End Sub


#End Region

End Class
