﻿Imports System.Windows.Forms
Imports YiaoWang.DataBase
Imports YiaoWang.Network
Imports YiaoWang.Utility
Imports YiaoWang.Vender.Office
Imports YiaoWang.Windows.Forms

''' <summary>
''' YiaoWang.YWNetwork クラスの実装サンプルです。
''' </summary>
''' <remarks></remarks>
Friend Class YWNetworkSample

#Region " New "

    Public Sub New()
        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' サンプル用の初期値を設定します。
        Me.InitializeForYWHtmlWriter()
    End Sub

#End Region

#Region " YWWebUtility "

    ''' <summary>
    ''' URLからファイル名を取得します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>正確にいえば、/ で区切った末尾の値を取得しています。</remarks>
    Private Sub btnGetFileName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetFileName.Click
        Dim s As String = YWWebUtility.GetFileName(Me.txtGetFileName.Text)
        Dim msg As New YWMsg()
        msg.AddLN(s)
        msg.ShowI()
    End Sub

#End Region

#Region " YWHtmlWriter "

    ''' <summary>
    ''' YWHtmlWriter のための初期値を設定します。
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub InitializeForYWHtmlWriter()
        Dim dt As New DataTable()
        dt.Columns.Add("ID")
        dt.Columns.Add("NAME")
        dt.Rows.Add(1, "山田太郎")
        dt.Rows.Add(2, "鈴木花子")
        Me.dgvYWHtmlWriter.SetDataTable(dt)
    End Sub

    ''' <summary>
    ''' HTML形式のファイルを作成します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>YWFileDialogButton のClick イベントを使用しています。</remarks>
    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim html As New YWHtmlWriter(Me.btnWrite.FileName, False, System.Text.Encoding.UTF8)
        html.WriteLTagLN("HTML")
        html.WriteLTagLN("BODY")
        html.Indent += 4
        html.WriteLN("サンプルページ")
        html.Indent -= 4
        html.WriteRTagLN("BODY")
        html.WriteRTagLN("HTML")
        html.Close()
    End Sub

    ''' <summary>
    ''' DataTable の値を基にHTML形式のファイルを作成します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>WFileDialogButton のClick イベントを使用しています。</remarks>
    Private Sub btnSaveList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveList.Click
        YWHtmlWriter.SaveList(Me.btnSaveList.FileName, Me.dgvYWHtmlWriter.GetDataTable, True)
    End Sub

#End Region

#Region " YWNtpClient "

    ''' <summary>
    ''' NTPサーバーから時刻を取得します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnTryGetNtpServerTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTryGetNtpServerTime.Click
        Try
            Dim ntp As New YWNtpClient(Me.txtServerName.Text)
            Dim ntpTime As Date
            If Not ntp.TryGetNtpServerTime(ntpTime) Then
                Dim msg As New YWMsg()
                msg.Add("NTPサーバーから時刻を取得できなかったため、自PCのシステム時刻を表示します。")
                msg.Add(ntpTime.ToString())
                msg.ShowA()
            Else
                Dim msg As New YWMsg()
                msg.Add(ntpTime.ToString())
                msg.ShowI()
            End If
        Catch ex As Exception
            Dim msg As New YWMsg()
            msg.Add(ex.Message)
            msg.ShowE()
        End Try
    End Sub

#End Region

End Class
