﻿Imports System.Windows.Forms
Imports YiaoWang.DataBase
Imports YiaoWang.Network
Imports YiaoWang.Utility
Imports YiaoWang.Vender.Office
Imports YiaoWang.Windows.Forms

Public Class YwOfficeSample

#Region " New "

    Public Sub New()
        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

    End Sub

#End Region

#Region " 基本形 "

    ''' <summary>
    ''' Excelを新規に作成します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnExcelShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExcelShow.Click
        Using xls As New YWExcel()
            Try
                ' 所定の位置に値を設定する。
                xls.ActiveSheet.Cells.Write(3, 2, "B3に値を設定⇒行追加＝現在B4に値が設定。")
                xls.ActiveSheet.Cells.Write("A2", "A2に値を設定")

                ' 折り返して全体を表示する。
                xls.ActiveSheet.Cells.SetWrapText(3, 2, True)

                ' 3行目に行追加をする。
                xls.ActiveSheet.Rows.InsertWithFormat(3)

                ' 罫線を引く。
                xls.ActiveSheet.WriteBorders(6, 2, 8, 4, YWExcelEdges.All, YWExcelLines.ContinuousAndThin)

                ' Excelを可視化する。
                xls.Visible = True
            Catch ex As Exception
                ' Excel を可視化して残す場合以外は必ず終了させます。
                ' （Quit しないと非可視のままタスクに残り続けます。）
                xls.Quit()
            End Try
        End Using
    End Sub

    ''' <summary>
    ''' 印刷プレビューを表示します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnExcelPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExcelPreview.Click
        Using xls As New YWExcel()
            Try
                ' 所定の位置に値を設定する。
                xls.ActiveSheet.Cells.Write(1, 1, "印刷プレビュー")

                ' 印刷プレビューをする。（PrintOut だと印刷されます。）
                xls.PrintPreview()
            Finally
                ' Excel を可視化して残す場合以外は必ず終了させます。
                ' （Quit しないと非可視のままタスクに残り続けます。）
                xls.Quit()
            End Try
        End Using
    End Sub

#End Region

#Region " DataTableの値を出力する "

    ''' <summary>
    ''' DataTable の値を Excel に出力します。
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnExcelDataShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExcelDataShow.Click
        ' Excel に出力するためのダミーデータを作成する。
        Dim dt As New DataTable
        dt.Columns.Add("A")
        dt.Columns.Add("B")
        dt.Rows.Add("あ", "い")
        dt.Rows.Add("う", "え")

        Using xls As New YWExcel()
            ' (1,1) を基準として DataTable を Excel に展開する。
            xls.ActiveSheet.Cells.Write(1, 1, dt)

            ' (1,1) を基準として DataTable の範囲で罫線を引く。
            xls.ActiveSheet.WriteBorders(1, 1, dt.Rows.Count, dt.Columns.Count, YWExcelEdges.All, YWExcelLines.ContinuousAndThin)

            ' Excelを可視化する。
            xls.Visible = True
        End Using
    End Sub

#End Region

End Class
